hdu1828 线段树+离散化+扫描线

添加lb[],rb[]数组,来标记竖边。添加num,来计算竖边的个数,因为计算周长的时候,未覆盖的竖边都要加

#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<algorithm>
using namespace std;
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1
#define maxn 10100
bool lb[maxn<<2],rb[maxn<<2];
struct seg
{
    int l,r,h;
    int f;
}s[maxn];
struct node
{
    int cnt;
    int num;
    int len;
}tree[maxn<<2];
int mark[maxn<<2];
int min(int x,int y)
{
    return x<y?x:y;
}
int max(int x,int y)
{
    return x>y?x:y;
}
bool cmp(seg a,seg b)
{
    return a.h<b.h;
}
void getlen(int l,int r,int rt)
{
    if(tree[rt].cnt)
    {
        lb[rt]=rb[rt]=true;//标记竖边是否被使用
        tree[rt].len=mark[r+1]-mark[l];
        tree[rt].num=2;
    }
    else if(l==r)
        tree[rt].len=tree[rt].num=lb[rt]=rb[rt]=0;
    else
    {
        tree[rt].len=tree[rt<<1].len+tree[rt<<1|1].len;
        tree[rt].num=tree[rt<<1].num+tree[rt<<1|1].num;
        lb[rt]=lb[rt<<1];rb[rt]=rb[rt<<1|1];
        if(rb[rt<<1]&&lb[rt<<1|1])//左孩子的右边和右孩子左边已经被使用 那这2条就不需要加
            tree[rt].num-=2;
    }
}
void updata(int L,int R,int c,int l,int r,int rt)
{
    if(L<=l&&R>=r)
    {
        tree[rt].cnt+=c;
        getlen(l,r,rt);
        return ;
    }
    int m=(l+r)/2;
    if(m>=L)
        updata(L,R,c,lson);
    if(R>m)
        updata(L,R,c,rson);
    getlen(l,r,rt);
}
int find(int val,int num)
{
    int l,r,m;
    l=0;r=num;
    while(l<=r)
    {
        m=(l+r)/2;
        if(val==mark[m])
            return m;
        else if(val>mark[m])
            l=m+1;
        else r=m-1;
    }
    return -1;
}
int main()
{
    int i,n,m,L,R;
    int x1,x2,y1,y2;
    while(scanf("%d",&n)!=EOF)
    {
        m=0;
        L=999999;
        R=-999999;
        memset(s,0,sizeof(s));
        for(i=0;i<n;i++)
        {
            scanf("%d%d%d%d",&x1,&y1,&x2,&y2);
            s[m].l=x1;s[m].r=x2;s[m].h=y1;mark[m]=x1;s[m++].f=1;
            s[m].l=x1;s[m].r=x2;s[m].h=y2;mark[m]=x2;s[m++].f=-1;
        }
        sort(mark,mark+m);

        int k=1;
        for(i=1;i<m;i++)
        {
            if(mark[i]!=mark[i-1])
                mark[k++]=mark[i];
        }

        memset(tree,0,sizeof(tree));
        memset(lb,false,sizeof(lb));
        memset(rb,false,sizeof(rb));
        sort(s,s+m,cmp);
        int ans=0,past=0;
        for(i=0;i<m;i++)
        {

            int ll=find(s[i].l,k-1);
            int rr=find(s[i].r,k-1)-1;
            updata(ll,rr,s[i].f,0,k-1,1);

            ans+=tree[1].num*(s[i+1].h-s[i].h);
            ans+=abs(tree[1].len-past);
            past=tree[1].len;
        }
        printf("%d\n",ans);

    }
}
时间: 2024-10-09 22:09:51

hdu1828 线段树+离散化+扫描线的相关文章

hdu1828 Picture(线段树+离散化+扫描线)两种方法

C - Picture Time Limit:2000MS     Memory Limit:10000KB     64bit IO Format:%I64d & %I64u Submit Status Description A number of rectangular posters, photographs and other pictures of the same shape are pasted on a wall. Their sides are all vertical or

POJ 2482 Stars in Your Window 线段树+离散化+扫描线

题面据说很美- 每个星星可以根据在窗口的左下角和右上角两个位置建立两条扫描线,之后就是简单的区间增减和求最大值操作了. 注意要处理在边界上的星星是不算的情况,其实只要把左右边界分别增减一个eps即可. #include <cstdio> #include <cstring> #include <iostream> #include <map> #include <set> #include <vector> #include <

HDU 1542 Atlantis 线段树+离散化+扫描线

题意:给出一些矩形的最上角坐标和右下角坐标,求这些矩形的面积并. NotOnlySuccess 线段树专辑中扫描线模板题,弱智的我对着大大的代码看了一下午才搞懂. 具体见思路见注释=.= #include <cstdio> #include <cstring> #include <algorithm> #include <vector> #define lson rt<<1,l,mid #define rson rt<<1|1,mid

poj3277--City Horizon(线段树+离散化+扫描线)

City Horizon Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 16206   Accepted: 4414 Description Farmer John has taken his cows on a trip to the city! As the sun sets, the cows gaze at the city horizon and observe the beautiful silhouette

【POJ 2482】 Stars in Your Window(线段树+离散化+扫描线)

[POJ 2482] Stars in Your Window(线段树+离散化+扫描线) Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 11294   Accepted: 3091 Description Fleeting time does not blur my memory of you. Can it really be 4 years since I first saw you? I still remembe

HDU 3642 线段树+离散化+扫描线

题意:给你N个长方体的左下角和右上角坐标,问你空间中有多少体积是被大于两个不同的立方体覆盖的.x,y~10^6 z~500 考虑到给的z比较小,所以可以直接枚举z,然后跑二维的扫描线就好. 关于处理被不同的线段覆盖三次的问题,可以维护四个信息,cnt,once,twice,more,然后相互推出结果就好. #include <cstdio> #include <cstring> #include <vector> #include <algorithm> #

hdu1255--覆盖的面积(线段树+离散化+扫描线)

E - 覆盖的面积 Time Limit:5000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Description 给定平面上若干矩形,求出被这些矩形覆盖过至少两次的区域的面积. Input 输入数据的第一行是一个正整数T(1<=T<=100),代表测试数据的数量.每个测试数据的第一行是一个正整数N(1<=N<=1000),代表矩形的数量,然后是N行数据,每一行包含

poj1151-- Atlantis(线段树+离散化+扫描线)

Atlantis Time Limit:1000MS     Memory Limit:10000KB     64bit IO Format:%I64d & %I64u Submit Status Description There are several ancient Greek texts that contain descriptions of the fabled island Atlantis. Some of these texts even include maps of pa

POJ 1177/HDU 1828 picture 线段树+离散化+扫描线 轮廓周长计算

求n个图矩形放下来,有的重合有些重合一部分有些没重合,求最后总的不规则图型的轮廓长度. 我的做法是对x进行一遍扫描线,再对y做一遍同样的扫描线,相加即可.因为最后的轮廓必定是由不重合的线段长度组成的,这样理论上是对的 要注意处理高度相同的线段,把底边优先处理(在代码里就是f标记为1的线段),因为若是一个矩形的底边和另一个矩形的上边重合,则这个轮廓肯定不能算 不过POJ和HDU的数据好像都比较弱,我没进行上面的细节处理也AC了,不过一个很简单的数据就会不对,所以还是要处理一下才是真正正确的代码 我